/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module top(
    clk     ,
    rst_n   ,
    rx_uart ,
    seg_sel ,
    segment
    );

    parameter      DATA_W         =         8;
    parameter      SEG_WID        =         8;
    parameter      SEL_WID        =         3;
    parameter      BCD_OUT        =        12;

    input                clk      ;
    input                rst_n    ;
    input                rx_uart  ;

    output[SEL_WID-1:0]  seg_sel  ;
    output[SEG_WID-1:0]  segment  ;

    wire   [SEL_WID-1:0]  seg_sel  ;
    wire   [SEG_WID-1:0]  segment  ;

    wire  [DATA_W-1 :0]  rx_dout        ;
    wire                 rx_dout_vld    ;
    wire  [BCD_OUT-1:0]  bcd_dout       ;
    wire                 bcd_dout_vld   ;

    uart_rx     u1(
        .clk          (  clk             ),
        .rst_n        (  rst_n           ),
        .din          (  rx_uart         ),
        .dout         (  rx_dout         ),
        .dout_vld     (  rx_dout_vld     )
    );

    bcd_water   u2(
        .clk          (  clk             ),
        .rst_n        (  rst_n           ),
        .din          (  rx_dout         ),
        .din_vld      (  rx_dout_vld     ),
        .dout         (  bcd_dout        ),
        .dout_vld     (  bcd_dout_vld    )
    );

    seg_disp#(.SEG_NUM(SEL_WID))    u3(
        .clk          (  clk             ),
        .rst_n        (  rst_n           ),
        .din          (  bcd_dout        ),
        .din_vld      (  bcd_dout_vld    ),
        .seg_sel      (  seg_sel         ),
        .segment      (  segment         ) 
    );


endmodule

